package com.glxp.udidl.admin.entity.chs;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.Serializable;
import lombok.Data;

/**
    * 医保耗材分类
    */
@ApiModel(value="com-glxp-udidl-admin-entity-chs-YbHcfl")
@Data
@TableName(value = "yb_hcfl")
public class YbHcflEntity implements Serializable {
    @TableId(value = "id", type = IdType.INPUT)
    @ApiModelProperty(value="")
    private Integer id;

    /**
     * 医用耗材分类代码
     */
    @TableField(value = "specificationCode")
    @ApiModelProperty(value="医用耗材分类代码")
    private String specificationCode;

    @TableField(value = "specificationId")
    @ApiModelProperty(value="")
    private Integer specificationId;

    /**
     * 三级分类代码
     */
    @TableField(value = "catalogcode")
    @ApiModelProperty(value="三级分类代码")
    private String catalogcode;

    /**
     * 一级分类名称(学科，品名）
     */
    @TableField(value = "catalogname1")
    @ApiModelProperty(value="一级分类名称(学科，品名）")
    private String catalogname1;

    /**
     * 二级分类名称(用途、品目）
     */
    @TableField(value = "catalogname2")
    @ApiModelProperty(value="二级分类名称(用途、品目）")
    private String catalogname2;

    /**
     * 三级分类名称(部位、功能、品种）
     */
    @TableField(value = "catalogname3")
    @ApiModelProperty(value="三级分类名称(部位、功能、品种）")
    private String catalogname3;

    /**
     * 医保通用代码
     */
    @TableField(value = "commonnamecode")
    @ApiModelProperty(value="医保通用代码")
    private String commonnamecode;

    /**
     * 医保通用名
     */
    @TableField(value = "commonname")
    @ApiModelProperty(value="医保通用名")
    private String commonname;

    /**
     * 材质代码
     */
    @TableField(value = "matrialcode")
    @ApiModelProperty(value="材质代码 ")
    private String matrialcode;

    /**
     * 耗材材质
     */
    @TableField(value = "matrial")
    @ApiModelProperty(value="耗材材质")
    private String matrial;

    /**
     * 规格代码
     */
    @TableField(value = "characteristiccode")
    @ApiModelProperty(value="规格代码")
    private String characteristiccode;

    /**
     * 规格(特征、参数）
     */
    @TableField(value = "characteristic")
    @ApiModelProperty(value="规格(特征、参数）")
    private String characteristic;

    /**
     * 分开收费
     */
    @TableField(value = "separateCharges")
    @ApiModelProperty(value="分开收费")
    private String separateCharges;

    /**
     * 支付类型
     */
    @TableField(value = "paymentType")
    @ApiModelProperty(value="支付类型")
    private String paymentType;

    /**
     * 支付标准
     */
    @TableField(value = "paymentStandard")
    @ApiModelProperty(value="支付标准")
    private String paymentStandard;

    /**
     * 是否在用
     */
    @TableField(value = "isusing")
    @ApiModelProperty(value="是否在用")
    private String isusing;

    /**
     * 规格状态
     */
    @TableField(value = "specificationType")
    @ApiModelProperty(value="规格状态")
    private String specificationType;

    /**
     * 产品状态
     */
    @TableField(value = "productStatusS")
    @ApiModelProperty(value="产品状态")
    private String productStatusS;

    /**
     * 产品数量
     */
    @TableField(value = "productCount")
    @ApiModelProperty(value="产品数量")
    private String productCount;

    @TableField(value = "compCount")
    @ApiModelProperty(value="")
    private String compCount;

    @TableField(value = "regCount")
    @ApiModelProperty(value="")
    private String regCount;

    @TableField(value = "goodsCount")
    @ApiModelProperty(value="")
    private String goodsCount;

    private static final long serialVersionUID = 1L;
}
